<?php
function lastfm_tracks($username = '', $num = 5, $list = true, $update = true, $linked  = true, $encode_utf8 = false) {
	global $lastfm_options;
	include_once(ABSPATH . WPINC . '/rss.php');

	$songs = fetch_rss('http://ws.audioscrobbler.com/1.0/user/'.$username.'/recenttracks.rss');

	if ($num <=0) $num = 1;
	if ($num >10) $num = 10;
	
	if ($list) echo '<ul class="lastfm">';
	
	if ($username == '') {
		if ($list) echo '<li>';
		echo 'Username not configured';
		if ($list) echo '</li>';
	} else {
			if ( empty($songs->items) ) {
				if ($list) echo '<li>';
				echo 'No recently listened tracks.';
				if ($list) echo '</li>';
			} else {
				foreach ( $songs->items as $song ) {
					$msg = htmlspecialchars($song['title']);
					if($encode_utf8) $msg = utf8_encode($msg);
					$link = $song['link'];
				
					if ($list) echo '<li class="lastfm-item">'; elseif ($num != 1) echo '<p class="lastfm-track">';
					if ($linked) { 
            echo '<a href="'.$link.'" class="lastfm-link">'.$msg.'</a>'; // Puts a link to the song.
          } else {
            echo $msg; // Only the song, no link.
          }
          if($update) {				
            $time = strtotime($song['pubdate']);
            
            if ( ( abs( time() - $time) ) < 86400 )
              $h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
            else
              $h_time = date(__('Y/m/d'), $time);

            echo sprintf( '%s' ,' <span class="lastfm-timestamp"><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>' );
           }   
           
           if ($list) echo '</li>'; elseif ($num != 1) echo '</p>';
				
					$i++;
					if ( $i >= $num ) break;
				}
			}	
		}
    if ($list) echo '</ul>';
	}

?>

<?php 
function make_month_dropdown() {
	global $wpdb, $tableposts, $month;
	$now = current_time('mysql');
	// Get the entries grouped by month and year
	$archiveEntries =
		$wpdb->get_results("SELECT DISTINCT YEAR(post_date) AS `year`,
		MONTH(post_date) AS `month`
		FROM $tableposts WHERE post_date < '$now' AND post_status = 'publish'
		GROUP BY YEAR(post_date), MONTH(post_date) ORDER BY post_date DESC");
	// Start form
	echo '<form action="'.get_settings('home').'/" method="get">';
	echo '<div><select name="m" class="small" onchange="this.form.submit();">';
	// Produce each line of the dropdown
	foreach($archiveEntries as $archiveEntry) {
		// Add leading zero
		$thisMonth = zeroise($archiveEntry->month,2);
		// value to be passed into query string
		$thisM = $archiveEntry->year.$thisMonth;
		echo "<option value=\"$thisM\"";
		// Preselect currently-viewed month
		if ($thisM == $_GET['m']) echo ' selected="selected" ';
		echo '>';
		echo $month[$thisMonth].' '.$archiveEntry->year;
		echo '</option>';
	}
	echo '</select>&nbsp;';
	echo '<input type="submit" value="&raquo;" />';
	echo '</div></form>';
}
?>